var scheduleList = '';
var sessionQuestionsList = '';
var presentersList = '';
var floorMapList = '';
var exhibitorsList = '';
var newsList = '';
var scheduleDates = '';
var lastSelectedDate = '';
var sponsorsList = '';
var attendeeInformation = "";
var db;
var isNewData = false;
var notificationsData;
var startUrl = '';
$(function(){
    notificationsData = [];
    if (window.localStorage.getItem('notificationsData'))
    {
        notificationsData = JSON.parse(window.localStorage.getItem('notificationsData'));
    }
    document.addEventListener("deviceready", function(){
        db = window.openDatabase("ImagesDb", 1, "ImagesDb", 50 * 1024 * 1024);
        db.transaction(populateDB, errorCB, successPopulatingDb);
    });
});
function populateDB(tx)
{
    tx.executeSql('CREATE TABLE IF NOT EXISTS images (id unique, data)');
}
function errorCB(err) {
    console.log("Error processing SQL: "+err.code);
}
function successCB() {
    console.log("DB Success");
}
function successPopulatingDb() {
	// fetching images from lists on  db populating success
    fetchImagesFromJSON(floorMapList, 'floorMapList');
    fetchImagesFromJSON(presentersList, 'presentersList');
    fetchImagesFromJSON(sponsorsList, 'sponsorsList');
}
$(document).on('pagebeforeshow',function(e,data){
    if ($.mobile.activePage.attr('id') != 'page1')
        showLoading();
});
$(document).on('pageload',function(e,data){
    if ($.mobile.activePage.attr('id') != 'page1')
        hideLoading();
});
$(document).on('pageshow',onPageshow);

function onPageshow(e,data){
    hideLoading();
    // getting the id of current page
    var currentPageId = $.mobile.activePage.attr('id');
    // page2 denotes schedule
    switch (currentPageId)
    {
    case 'page1':
        startUrl = 'page1';
        document.addEventListener("backbutton", function(){
            navigator.app.exitApp();
        }, false);
        // check if user is logged in
        if (!isGuestUser())
        {
            // show logout link if user is logged in
            $(".user-logout-container").removeClass("hidden");
            // unbind the click event on user logout button
            $("#user-logout").unbind("click", userLogoutAction);
            // bind logout function with the logout link
            $("#user-logout").bind("click", userLogoutAction);
            // if login link is not hidden then hide it
            if (!$(".user-login-container").hasClass("hidden"))
            {
                $(".user-login-container").addClass("hidden");
            }
        }
        // else hide logout link if its a guest user
        else
        {
            // if logout link is not hidden then hide it
            if (!$(".user-logout-container").hasClass("hidden"))
            {
                $(".user-logout-container").addClass("hidden");
            }
            // show login link if user is logged in
            $(".user-login-container").removeClass("hidden");
            // unbind the click event on user logout button
            $("#user-login").unbind("click");
            // bind logout function with the logout link
            $("#user-login").bind("click", function(){
                window.location = "./login.html";
            });
        }
        if (scheduleList == '')
        {
            var ajaxFetchedData = '';
            if (checkConnection())
            {
                ajaxFetchedData = fetchAjaxData();
            }
            isNewData = true;
            if (ajaxFetchedData == '' || ajaxFetchedData == false || ajaxFetchedData == null)
            {
                if (window.localStorage.getItem("ajaxFetchedData") != "" && window.localStorage.getItem("ajaxFetchedData") != null)
                {
                    ajaxFetchedData = JSON.parse(window.localStorage.getItem("ajaxFetchedData"));
                    isNewData = false;
                }
            }
            if (ajaxFetchedData)
            {
                window.localStorage.setItem("ajaxFetchedData", JSON.stringify(ajaxFetchedData));
                window.localStorage.setItem("versionInfo", ajaxFetchedData.version);
                scheduleList = ajaxFetchedData.event;
                sessionQuestionsList = ajaxFetchedData.eventQuestions;
                presentersList = ajaxFetchedData.presenter;
                floorMapList = ajaxFetchedData.floorMap;
                exhibitorsList = ajaxFetchedData.exhibitor;
                newsList = ajaxFetchedData.news;
                sponsorsList = ajaxFetchedData.sponsor;
                scheduleDates = fetchDatesFromSchedules(scheduleList);
                attendeeInformation = ajaxFetchedData.attendeeInformation;
                if (isNewData)
                {
                    /*
                     *  refreshing iteneraries if new data is retrieved
                     *  deleting the itenery event if its deleted from the server
                     */
                    refreshItineraries();
                    // fetching the logo image
                    var logoImage = ajaxFetchedData.logoImage;
                    var logoImageInfo = "data:"+ logoImage.type +";base64," + logoImage.data;
                    var logoImageObject = $.mobile.activePage.find("#logo-image");
                    // saving logo image data as local storage
                    window.localStorage.setItem("logoImageData", logoImageInfo);
                    window.localStorage.setItem("isLogoImageChanged", "true");
                    // displaying logo image
                    $(logoImageObject).prop('src', logoImageInfo);
                }
                else
                {
                	window.localStorage.setItem("isLogoImageChanged", "false");
                    var logoImageObject = $.mobile.activePage.find("#logo-image");
                    
                    // check if the logo image src is blank
                    if ($(logoImageObject).prop('src'))
                    {
                        // fetching logo image from localStorage and displaying
                        $(logoImageObject).prop('src',window.localStorage.getItem("logoImageData"));
                    }
                }
            }
        }
        break;
    case 'page2':
        startUrl = 'page2';
        // creating object of <ul> tag
        var listViewObject = $.mobile.activePage.find("#a2");
        $.mobile.activePage.find(".back-url").attr('href', '#page1');
        if ($(listViewObject).html() == "" || isNewData)
        {
            showLoading();
            setTimeout(function(){
                fillOptionsForDateSelection();
                $(listViewObject).html("");
                // binding change event to select menu
                $.mobile.activePage.find("#a1").bind("change", function(){
                    showLoading();
                    // calling fill data function on date change
                    lastSelectedDate = $(this).val();
                    fillSchedulePageData(listViewObject, lastSelectedDate);
                });
                // getting the selected date from select menu
                var selectedDate = $.mobile.activePage.find("#a1").val();
                lastSelectedDate = selectedDate;
                // calling fill data function to fill <ul>
                fillSchedulePageData(listViewObject, lastSelectedDate);
            },100);
        }
        break;
    case 'schedule-full-view':
        showLoading();
        if ($.mobile.pageData && $.mobile.pageData.eventId){
            var eventId = $.mobile.pageData.eventId;
            displayEvent(eventId);
        }
        hideLoading();
        break;
    case 'session-info':
        showLoading();
        if ($.mobile.pageData && $.mobile.pageData.eventId){
            var eventId = $.mobile.pageData.eventId;
            displaySessionInfo(eventId);
        }
        hideLoading();
        break;
    case 'floor-map':
        showLoading();
        if ($.mobile.pageData && $.mobile.pageData.floorMapId && $.mobile.pageData.returnUrl)
        {
            displayFloorMap($.mobile.pageData.floorMapId, $.mobile.pageData.returnUrl);
        }
        hideLoading();
        break;
    case 'sessions':
        startUrl = 'sessions';
        // creating object of <ul> tag
        var listViewObject = $.mobile.activePage.find("#a2");
        $.mobile.activePage.find(".back-url").attr('href', '#page1');
        if ($(listViewObject).html() == "" || isNewData)
        {
            showLoading();
            $(listViewObject).html("");
            
            // getting the selected date from select menu
            var selectedOption = $.mobile.activePage.find("#a1").val();
            var showHeaders = $.mobile.activePage.find("#a1 :selected").data("headers");
            // calling fill data function to fill <ul>
            fillSessionsPageData(listViewObject, selectedOption, showHeaders);

            // binding change event to select menu
            $.mobile.activePage.find("#a1").bind("change", function(){
                showHeaders = $.mobile.activePage.find("#a1 :selected").data("headers");
                // calling fill data function to fill <ul>
                fillSessionsPageData(listViewObject, $(this).val(), showHeaders);
            });
            
            hideLoading();
        }
        break;
    case 'presenters':
        startUrl = 'presenters';
        showLoading();
        $.mobile.activePage.find(".back-url").attr('href', '#page1');
        var listViewObject = $.mobile.activePage.find("#presenters-list");
        if ($(listViewObject).html() == "" || isNewData)
        {
            $(listViewObject).html("");
            addPresentersListItems(presentersList, listViewObject, 'add', "presenters")
            $(listViewObject).listview('refresh');
        }
        hideLoading();
        break;
    case 'session-speakers':
        showLoading();
        if ($.mobile.pageData != null && $.mobile.pageData != 'undefined')
        {
            if ($.mobile.pageData.viewSpeakersReturnUrl != null && $.mobile.pageData.viewSpeakersReturnUrl != 'undefined')
            {
                var backLink = '#' + $.mobile.pageData.viewSpeakersReturnUrl + '?eventId=' + $.mobile.pageData.eventId +'&scheduleFullView_returnUrl=' + $.mobile.pageData.scheduleFullView_returnUrl;
                if ($.mobile.pageData.presenterId != null && $.mobile.pageData.presenterId != 'undefined')
                {
                    backLink += '&presenterId=' + $.mobile.pageData.presenterId;
                }
                $('.back-url').attr('href',backLink);
            }
        }
        var listViewObject = $.mobile.activePage.find("#presenters-list");
        $(listViewObject).html("");

        var session = scheduleList[$.mobile.pageData.eventId];
        var sessionPresenters = session.presenterIDs;
        var sessionPanelists = session.panelistIDs;
        var sessionChairpersons = session.chairpersonIDs;

        var isSessionPresentersEmpty = true;
        var isSessionPanelistsEmpty = true;
        var isSessionChairpersonsEmpty = true;
        // if total presenters for the session is greater than 0
        if (getLengthOfObject(sessionPresenters) > 0)
        {
            // inserting the heading <li> tags
            $(listViewObject).append($('<li/>', {
                 'data-role': "list-divider",
                 'role': "heading",
                 'text': "Presenters"
            }));
            $.each(sessionPresenters, function(index, item) {
                renderPresenter(item, listViewObject, 'session-speakers');
            });
            isSessionPresentersEmpty = false;
        }
        // if total presenters for the session is greater than 0
        if (getLengthOfObject(sessionPanelists) > 0)
        {
            // inserting the heading <li> tags
            $(listViewObject).append($('<li/>', {
                 'data-role': "list-divider",
                 'role': "heading",
                 'text': "Panelists"
            }));
            $.each(sessionPanelists, function(index, item) {
                renderPresenter(item, listViewObject, 'session-speakers');
            });
            isSessionPanelistsEmpty = false;
        }
        // if total presenters for the session is greater than 0
        if (getLengthOfObject(sessionChairpersons) > 0)
        {
            // inserting the heading <li> tags
            $(listViewObject).append($('<li/>', {
                 'data-role': "list-divider",
                 'role': "heading",
                 'text': "Chairpersons"
            }));
            $.each(sessionChairpersons, function(index, item) {
                renderPresenter(item, listViewObject, 'session-speakers');
            });
            isSessionChairpersonsEmpty = false;
        }
        $(listViewObject).listview('refresh');
        if (isSessionChairpersonsEmpty && isSessionPanelistsEmpty && isSessionPresentersEmpty)
        {
            $(listViewObject).html('<div data-role="content" class="noSessionSpeakers ui-content ui-body-e" data-display="false" data-theme="e" role="main">There are no speakers for this session.</div>');
        }
        hideLoading();
        break;
    case 'presenter-full-view':
        showLoading();
        if ($.mobile.pageData && $.mobile.pageData.presenterId)
        {
            var presenterId = $.mobile.pageData.presenterId;
            displayPresenterDetails(presenterId);
        }
        hideLoading();
        break;
    case 'speaker-sessions':
        // creating object of <ul> tag
        var listViewObject = $.mobile.activePage.find("#presenter-sessions-list");
        var backUrl = '#presenter-full-view?presenterId=' + $.mobile.pageData.presenterId + '&presenterFullViewReturnUrl=' + $.mobile.pageData.presenterFullViewReturnUrl;
        if ($.mobile.pageData != null && $.mobile.pageData.eventId != null && $.mobile.pageData.eventId != 'undefined')
        {
            backUrl += '&eventId=' + $.mobile.pageData.eventId;
        }
        $.mobile.activePage.find(".back-url").attr('href', backUrl);
        
        $(listViewObject).html("");
        showLoading();
        sessionsList = presentersList[$.mobile.pageData.presenterId].sessions;
        if (getLengthOfObject(sessionsList) > 0)
        {
            $.each(sessionsList, function(index, item) {
                renderEvent(item, listViewObject, 'speaker-sessions&presenterId=' + $.mobile.pageData.presenterId +'&presenterFullViewReturnUrl=' + $.mobile.pageData.presenterFullViewReturnUrl + '&speakerSessionsReturnUrl=presenter-full-view' );
            });
        }
        else
        {
            $(listViewObject).html('<div data-role="content" class="noSpeakerSessions ui-content ui-body-e" data-display="false" data-theme="e" role="main">There are no sessions for this presenter</div>');
        }
        $(listViewObject).listview('refresh');
        hideLoading();
        break;
    case 'attendee-information':
        showLoading();
        $.mobile.activePage.find(".back-url").attr('href', '#page1');
        $.mobile.activePage.find("#info-page-menu").bind("change", function(){
            $.mobile.activePage.find(".attendee-information-sub-page").removeClass("attendee-information-sub-page-active");
            $.mobile.activePage.find("#"+$(this).val()).addClass("attendee-information-sub-page-active");
            switchAttendeeInformationPage($(this).val());
        });
        switchAttendeeInformationPage($.mobile.activePage.find("#info-page-menu").val());
        hideLoading();
        break;
    case 'exhibitor-full-view':
        showLoading();
        exhibitorId = $.mobile.pageData.exhibitorId;
        returnUrl = $.mobile.pageData.returnUrl;
        displayExhibitorDetails($.mobile.pageData.exhibitorId, returnUrl);
        hideLoading();
        break;
    case 'news-full-view':
        showLoading();
        newsId = $.mobile.pageData.newsId;
        returnUrl = $.mobile.pageData.returnUrl;
        displayNewsDetails(newsId, returnUrl);
        hideLoading();
        break;
    case 'sponsors':
        $.mobile.activePage.find(".back-url").attr('href', '#page1');
        var listViewObject = $.mobile.activePage.find("#sponsors-list");
        if ($(listViewObject).html() == "" || isNewData)
        {
            showLoading();
            $(listViewObject).html("");
            addSponsorsListItems(sponsorsList, listViewObject, 'add', "sponsors")
            $(listViewObject).listview('refresh');
            hideLoading();
        }
        break;
    case 'sponsor-full-view':
        showLoading();
        if ($.mobile.pageData && $.mobile.pageData.sponsorId)
        {
            var sponsorId = $.mobile.pageData.sponsorId;
            displaySponsorDetails(sponsorId);
        }
        hideLoading();
        break;
    case 'itinerary':
        startUrl = 'itinerary';
        showLoading();
        // creating object of <ul> tag
        var listViewObject = $.mobile.activePage.find("#userItineraryList");
        $.mobile.activePage.find(".back-url").attr('href', '#page1');
        $(listViewObject).html("");
        // calling fill data function to fill <ul>
        fillItineraryPageData(listViewObject);
        hideLoading();
        break;
    case 'send-message':
        showLoading();
        // check if user is logged in
        if (!isGuestUser())
        {
            // remove user not logged in message
            if (!$(".no-user").hasClass("hidden"))
            {
                $(".no-user").addClass("hidden");
            }
            // show send message form
            $(".send-message-form").removeClass("hidden");
            // unbinding the previous binded function
            $("#send-message-form").unbind("submit", sendMessageFormAction);

            // binding function on send message form submit
            $("#send-message-form").bind("submit", sendMessageFormAction);
        }
        // else if user not logged in
        else
        {
            // hide the send message form
            if (!$(".send-message-form").hasClass("hidden"))
            {
                $(".send-message-form").addClass("hidden");
            }
            // show the user not logged in message
            $(".no-user").removeClass("hidden");
        }
        hideLoading();
        break;
    case 'session-ask-question':
            var eventId = $.mobile.pageData.eventId;
            var userDetails = JSON.parse(window.localStorage.getItem("userDetails"));
            var userId = userDetails.id;
            var eventRow = scheduleList[eventId];
            var eventIdToSend = eventId.replace(eventRow.date + '-', '');
            $.mobile.activePage.find("#session_id").val(eventIdToSend);
            $.mobile.activePage.find("#user_id").val(userId);
            $(".session-question-form").unbind('submit');
            $(".session-question-form").bind('submit',function(ev){
                ev.preventDefault();
                var ajaxResult = sendAjaxRequest(baseUrl + '/site/saveSessionQuestion',$(this).serializeArray(), 'POST','JSON');
                if (ajaxResult)
                {
                    ui_alert('Question has been posted successfully');
                    $('.ui-dialog').dialog('close');
                }
                else
                {
                    ui_alert('Internet Connection Error!');
                }
                $.mobile.activePage.find("#session-question").val("");
                return false;
            });
        break;
    case 'session-rate':
            var eventId = $.mobile.pageData.eventId;
            var userDetails = JSON.parse(window.localStorage.getItem("userDetails"));
            var userId = userDetails.id;
            var eventRow = scheduleList[eventId];
            var eventIdToSend = eventId.replace(eventRow.date + '-', '');
            $.mobile.activePage.find("#session_id").val(eventIdToSend);
            $.mobile.activePage.find("#user_id").val(userId);
            $(".session-rate-form").unbind('submit');
            $(".session-rate-form").bind('submit', function(ev){
                ev.preventDefault();
                var ajaxResult = sendAjaxRequest(baseUrl + '/site/saveSessionReview',$(this).serializeArray(), 'POST','JSON');
                if (ajaxResult)
                {
                    ui_alert('Rating and Review has been posted successfully');
                    $('.ui-dialog').dialog('close');
                }
                else
                {
                    ui_alert('Internet Connection Error!');
                }
                $.mobile.activePage.find("#session-question").val("");
                return false;
            });
        break;
    case 'speaker-rate':
        var presenterId = $.mobile.pageData.presenterId;
        var userDetails = JSON.parse(window.localStorage.getItem("userDetails"));
        var userId = userDetails.id;
        $.mobile.activePage.find("#speaker_id").val(presenterId);
        $.mobile.activePage.find("#user_id").val(userId);
        $(".session-rate-form").unbind('submit');
        $(".session-rate-form").bind('submit', function(){
            var ajaxResult = sendAjaxRequest(baseUrl + '/site/saveSpeakerReview',$(this).serializeArray(), 'POST','JSON');
            if (ajaxResult)
            {
                ui_alert('Rating and Review has been posted successfully');
                $('.ui-dialog').dialog('close');
            }
            else
            {
                ui_alert('Internet Connection Error!');
            }
            $.mobile.activePage.find("#session-question").val("");
            return false;
        });
        break;
    case 'session-questions':
        if ($.mobile.pageData && $.mobile.pageData.eventId)
        {
            showLoading();
            if ($.mobile.pageData != null && $.mobile.pageData != 'undefined')
            {
                if ($.mobile.pageData.viewQuestionsReturnUrl != null && $.mobile.pageData.viewQuestionsReturnUrl != 'undefined')
                {
                    var backLink = '#' + $.mobile.pageData.viewQuestionsReturnUrl + '?eventId=' + $.mobile.pageData.eventId +'&scheduleFullView_returnUrl=' + $.mobile.pageData.scheduleFullView_returnUrl;
                    if ($.mobile.pageData.presenterId != null && $.mobile.pageData.presenterId != 'undefined')
                    {
                        backLink += '&presenterId=' + $.mobile.pageData.presenterId;
                    }
                    $('.back-url').attr('href',backLink);
                }
            }
            // creating object of <ul> tag
            var listViewObject = $.mobile.activePage.find("#session-questions-list");
            var eventId = $.mobile.pageData.eventId;
            var userDetails = JSON.parse(window.localStorage.getItem("userDetails"));
            fillSessionQuestionsPageData(listViewObject, eventId);
            hideLoading();
        }
        break;
    case 'session-answer-question':
            var eventId = $.mobile.pageData.eventId;
            var eventQuestionId = $.mobile.pageData.event_question_id;
            var userDetails = null;
            var userId = null;
            $("#session-question-body").html("");
            $("#sqo-1 span.ui-btn-text").text("");
            $("#sqo-2 span.ui-btn-text").text("");
            $("#sqo-3 span.ui-btn-text").text("");
            $("#sqo-4 span.ui-btn-text").text("");
            if (!isGuestUser())
            {
                userDetails = JSON.parse(window.localStorage.getItem("userDetails"));
                userId = userDetails.id;
            }
            var eventRow = scheduleList[eventId];
            var eventQuestionRow = null;
            $.each(eventRow.eventQuestions, function(index, item) {
                if (item.id == eventQuestionId)
                {
                    eventQuestionRow = item;
                }
            });
            if (eventQuestionRow !== null)
            {
                $(".session-question-options").removeAttr("checked");
                var userSelectedOption = getUserSelectedOption(eventQuestionRow.id);
                
                if (userSelectedOption != null)
                {
                    $.mobile.activePage.find(".session-question-option-" + userSelectedOption)[0].checked = true
                }
                $(".session-question-options").checkboxradio("refresh");
                
                $("#session-question-body").html(eventQuestionRow.question);
                $("#sqo-1 span.ui-btn-text").text(eventQuestionRow.option_1);
                $("#sqo-2 span.ui-btn-text").text(eventQuestionRow.option_2);
                $("#sqo-3 span.ui-btn-text").text(eventQuestionRow.option_3);
                $("#sqo-4 span.ui-btn-text").text(eventQuestionRow.option_4);
            }
            var eventIdToSend = eventId.replace(eventRow.date + '-', '');
            $.mobile.activePage.find("#event_question_id").val(eventQuestionRow.id);
            $.mobile.activePage.find("#user_id").val(userId);
            if (eventQuestionRow == null)
            {
                $(".session-question-answer-form").unbind('submit');
                $(".session-question-answer-form").bind('submit',function(ev){
                    ui_alert('Answer submitted successfully.');
                    setTimeout(function(){
                        $('.ui-dialog').dialog('close');
                    },2000);
                    return false;
                });
            }
            else if (isGuestUser())
            {
                $(".session-question-answer-form").unbind('submit');
                $(".session-question-answer-form").bind('submit',function(ev){
                    ui_alert('Login required to submit answer.');
                    setTimeout(function(){
                        $('.ui-dialog').dialog('close');
                    },2000);
                    return false;
                });
            }
            else
            {
                $(".session-question-answer-form").unbind('submit');
                $(".session-question-answer-form").bind('submit',function(ev){
                    ev.preventDefault();
                    var ajaxResult = sendAjaxRequest(baseUrl + '/site/saveSessionQuestionAnswer', $(this).serializeArray(), 'POST', 'JSON');
                    if (ajaxResult)
                    {
                        setUserSelectedOption(eventQuestionRow.id, $(".session-question-options:checked").val());
                        ui_alert('Your answer has been saved successfully');
                        setTimeout(function(){
                            $('.ui-dialog').dialog('close');
                        },2000);
                    }
                    else
                    {
                        ui_alert('Internet Connection Error!');
                    }
                    return false;
                });
            }
        break;
    }
}

/*
 * function is used to switch the data in #attendee-information when the user selects
 * between information / maps / news / exhibitors
 */
function switchAttendeeInformationPage(selectedPage)
{
    if (selectedPage == 'exhibitors')
    {
        var listViewObject = $.mobile.activePage.find("#exhibitors #items-list");
        if ($(listViewObject).html() == "" || isNewData)
        {
            $.mobile.activePage.find("#title").html('Exhibitors');
            $(listViewObject).html("");
            addExhibitorsListItems(exhibitorsList, listViewObject, "add", "attendee-information");
            $(listViewObject).listview('refresh');
        }
    }
    else if (selectedPage == 'maps')
    {
        var listViewObject = $.mobile.activePage.find("#maps #items-list");
        if ($(listViewObject).html() == "" || isNewData)
        {
            $.mobile.activePage.find("#title").html('Maps');
            $(listViewObject).html("");
            addMapsListItems(floorMapList, listViewObject, "add", "maps");
            $(listViewObject).listview('refresh');
        }
    }
    else if (selectedPage == 'news')
    {
        var listViewObject = $.mobile.activePage.find("#news #items-list");
        if ($(listViewObject).html() == "" || isNewData)
        {
            $.mobile.activePage.find("#title").html('News');
            $(listViewObject).html("");
            addNewsListItems(newsList, listViewObject, "add", "attendee-information");
            $(listViewObject).listview('refresh');
        }
    }
    else if (selectedPage == 'information')
    {
        $.mobile.activePage.find("#title").html('Attendee Information');
        $.mobile.activePage.find("#attendee_information_text").html(attendeeInformation)
    }
    else if (selectedPage == 'notifications')
    {
        var listViewObject = $.mobile.activePage.find("#notifications #items-list");
        $.mobile.activePage.find("#title").html('Messages');
        var notificationsData = [];
        if (window.localStorage.getItem('notificationsData'))
        {
            notificationsData = JSON.parse(window.localStorage.getItem('notificationsData'));
        }
        if ( notificationsData.length > 0)
        {
            $(listViewObject).html("");
            addNotificationListItems(notificationsData, listViewObject, "add");
            $(listViewObject).listview('refresh');
        }
        else
        {
            text = 'There are no messages for you.';
            html = '';
            html = document.createElement('div');
            $(html).addClass('presenter-details');
            $(html).append($('<div/>', {
                'class': 'noMessages ui-content ui-body-e',
                'text' : text,
                'data-theme' : 'e'
            }));

            // inserting the <li> tags containing links
            $(listViewObject).html($('<li/>', {
                'data-theme': "c"
            }).append($('<span/>', {
                'html': html
            })));
        }
    }
}

/*
 *  function is used to display the data in #page2
 */
function fillSchedulePageData(listViewObject, selectedDate)
{
    // empty the <UL>, this removes previous data
    $(listViewObject).html("");
    
    var listForSelectedDate = fetchListForDate(selectedDate);
    
    if (listForSelectedDate)
    {
        var html = '';
        // fetching distinct starts at time from the list
        var startsAtArray = fetchFilteredListHeaders(listForSelectedDate, 'startsAt');
        var listForStartsAt = '';
        $.each(startsAtArray, function(index, startAtTime) {
            // fetching list for current iterating startsAt time
            listForStartsAt = fetchListForHeader(listForSelectedDate, 'startsAt', startAtTime);
            var timepieces = startAtTime.match(/.{1,2}/g);
            if (timepieces.length == 2)
            {
                startAtTime = timepieces[0] + ":" + timepieces[1];
            }
            // inserting the heading <li> tags
            $(listViewObject).append($('<li/>', {
                 'data-role': "list-divider",
                 'role': "heading",
                 'text': startAtTime
            }).append($("<spoan/>",{
                'class': 'pull-right',
                'text': selectedDate
            })));
            addEventListItems(listForStartsAt, listViewObject, 'append', 'page2');
        });
        $(listViewObject).listview('refresh');
        hideLoading();
    }
}

/*
 * function returns array containing
 * distinct dates values from list
 */
function fetchDatesFromSchedules(listData)
{
    if (listData == '')
    {
        listData = scheduleList;
    }
    var dates = [];
    $.each(listData, function(eventId, eventData) {
        if (dates.indexOf(eventData.date) == -1)
        {
            dates.push(eventData.date);
        }
    });
    return dates;
}

/*
 *  function is used to fill options in the Select Menu in #page2
 */
function fillOptionsForDateSelection()
{
    var selectedDateValue = 'None';
    if ($.mobile.activePage.find("#a1 option").length > 0)
    {
        selectedDateValue = $.mobile.activePage.find("#a1").val();
    }
    $.mobile.activePage.find("#a1").html("");
    $.each(scheduleDates, function(index, date) {
        if (date == selectedDateValue)
        {
            $.mobile.activePage.find("#a1").append($('<option/>', {
                'value' : date,
                'html' : date,
                'selected' : 'selected'
            }));
        }
        else
        {
            $.mobile.activePage.find("#a1").append($('<option/>', {
                'value' : date,
                'html' : date
            }));
        }
    });
    $.mobile.activePage.find("#a1").selectmenu('refresh');
}

/*
 * function returns list filtered by the date value from Select Menu in #page2
 */
function fetchListForDate(selectedDate)
{
    var list = {};
    $.each(scheduleList, function(key, value) {
        if (value.date == selectedDate)
        {
            list[key] = value;
        }
    });
    return list;
}

/*
 *  function is used to display event full details in #schedule-full-view
 */
function displayEvent(eventId)
{
    eventObject = scheduleList[eventId];
    if ($.mobile.pageData.scheduleFullView_returnUrl)
    {
        var scheduleFullView_returnUrl = "#" + $.mobile.pageData.scheduleFullView_returnUrl + '?';
        if ($.mobile.pageData.scheduleFullView_returnUrl == 'speaker-sessions')
        {
            scheduleFullView_returnUrl += '&presenterId=' + $.mobile.pageData.presenterId + '&speakerSessionsReturnUrl=' + $.mobile.pageData.speakerSessionsReturnUrl + '&presenterFullViewReturnUrl=' + $.mobile.pageData.presenterFullViewReturnUrl;
            
        }
        $.mobile.activePage.find("#back-url").attr("href", scheduleFullView_returnUrl);
    }

    if(startUrl == 'sessions' || startUrl == 'itinerary' || startUrl == 'page2')
    {
        $.mobile.activePage.find("#back-url").attr("href", '#' + startUrl);
    }
    var viewSpeakersUrl = '#session-speakers?eventId=' + eventId + '&viewSpeakersReturnUrl=' + 'schedule-full-view&scheduleFullView_returnUrl=' + $.mobile.pageData.scheduleFullView_returnUrl;
    var viewQuestionsUrl = '#session-questions?eventId=' + eventId + '&viewQuestionsReturnUrl=' + 'schedule-full-view&scheduleFullView_returnUrl=' + $.mobile.pageData.scheduleFullView_returnUrl;
    if ($.mobile.pageData.scheduleFullView_returnUrl == 'speaker-sessions')
    {
        viewSpeakersUrl += '&presenterId=' + $.mobile.pageData.presenterId + '&presenterFullViewReturnUrl=' + $.mobile.pageData.presenterFullViewReturnUrl + '&speakerSessionsReturnUrl=' + $.mobile.pageData.speakerSessionsReturnUrl;
    }
    $.mobile.activePage.find("#title").html(eventObject.title);
    $.mobile.activePage.find("#event-description").html(eventObject.fullDescription);
    $.mobile.activePage.find("#event-venue").html(eventObject.venue);
    $.mobile.activePage.find(".event-date").html(eventObject.date);
    $.mobile.activePage.find(".event-duration").html(eventObject.startsAt + ' - ' + eventObject.endsAt);
    $.mobile.activePage.find("#event-type").html(eventObject.type);
    $.mobile.activePage.find(".session-info-container").html(eventObject.sessionInfo);
    $.mobile.activePage.find("#view-speakers").attr('href',viewSpeakersUrl);
    $.mobile.activePage.find("#view-event-questions").attr('href',viewQuestionsUrl);
    if (isGuestUser())
    {
        $.mobile.activePage.find("#event-ask-question").attr('href','javascript:ui_alert("Login Required");');
        $.mobile.activePage.find("#event-rate").attr('href','javascript:ui_alert("Login Required");');
    }
    else
    {
        $.mobile.activePage.find("#event-ask-question").attr('href','#session-ask-question?eventId=' + eventId);
        $.mobile.activePage.find("#event-rate").attr('href','#session-rate?eventId=' + eventId);
    }
    var userItineraries = [];
    if (window.localStorage.getItem("userItineraries"))
    {
        userItineraries = JSON.parse(window.localStorage.getItem("userItineraries"));
    }
    var indexOf = userItineraries.indexOf(eventId);
    
    // check if event is in itinerary list
    if (indexOf != -1)
    {
        // add class active to the link
        $.mobile.activePage.find(".addToItinerary").attr('data-is_itinerary','1');
        $.mobile.activePage.find(".addToItinerary").prop('title','Remove from My Itinerary');
        $.mobile.activePage.find(".addToItinerary").find('.icon-leftbar').removeClass('icon-leftbar-calender-inactive');
        $.mobile.activePage.find(".addToItinerary").find('.icon-leftbar').addClass('icon-leftbar-calender-active');
    }
    else
    {
        // add class inactive to the link
        $.mobile.activePage.find(".addToItinerary").attr('data-is_itinerary','0');
        $.mobile.activePage.find(".addToItinerary").prop('title','Add to My Itinerary');
        $.mobile.activePage.find(".addToItinerary").find('.icon-leftbar').removeClass('icon-leftbar-calender-active');
        $.mobile.activePage.find(".addToItinerary").find('.icon-leftbar').addClass('icon-leftbar-calender-inactive');
    }
    // unbind previous click event from add to itinerary checkbox
    $.mobile.activePage.find(".addToItinerary").off("click");
    // bind click event to add to itinerary checkbox
    $.mobile.activePage.find(".addToItinerary").on( "click", function(event, ui) {
        userItineraries = [];
        if (window.localStorage.getItem("userItineraries"))
        {
            userItineraries = JSON.parse(window.localStorage.getItem("userItineraries"));
        }
        indexOf = userItineraries.indexOf(eventId);
        // if session is not in itinerary list
        if ($(this).attr('data-is_itinerary') == '0')
        {
            // check if event is already in the userItineraries list
            if (indexOf == '-1')
            {
                // push event to userItineraries list if not there
                userItineraries.push(eventId);
            }
            $(this).attr('data-is_itinerary','1');
            $(this).prop('title','Remove from My Itinerary');
            $(this).find('.icon-leftbar').removeClass('icon-leftbar-calender-inactive');
            $(this).find('.icon-leftbar').addClass('icon-leftbar-calender-active');
            ui_alert('Added to Itinerary', 1000);
            var eventDatePieces = eventObject.date.split(/-/g);
            var eventTimePieces = eventObject.startsAt.match(/.{1,2}/g);
            var eventDateTime = new Date(eventDatePieces[0],parseInt(eventDatePieces[1])-1,eventDatePieces[2], eventTimePieces[0], eventTimePieces[1],0,0).getTime();
            if (eventDateTime > new Date().getTime())
            {
                registerLocalPush({
                    id: eventId,
                    date: new Date(eventDateTime - 5*60*1000),
                    message: eventObject.title + ' will start start shortly @ '+ eventObject.venue +' .',
                    title: 'Pedicon 2015',
                    json: {
                        id: eventId,
                    }
                });
            }
        }
        else
        {
            // check if event is there in the userItineraries list
            if (indexOf != '-1')
            {
                // if there then remove it from the userItineraries list
                userItineraries.splice(indexOf, 1);
            }
            $(this).attr('data-is_itinerary','0');
            $(this).prop('title','Add to My Itinerary');
            $(this).find('.icon-leftbar').removeClass('icon-leftbar-calender-active');
            $(this).find('.icon-leftbar').addClass('icon-leftbar-calender-inactive');
            ui_alert('Removed from Itinerary', 1000);
            unRegisterLocalPush(eventId);
        }
        // reset the localStorage for userItineraries list
        window.localStorage.setItem("userItineraries",JSON.stringify(userItineraries));
    });
}

/*
 *  function is used to display the session information in #session-info
 */
function displaySessionInfo(eventId)
{
    eventObject = scheduleList[eventId];
    $.mobile.activePage.find("#back-url").attr('href','#schedule-full-view?eventId=' + eventId);
    $.mobile.activePage.find("#title").html(eventObject.title);
    $.mobile.activePage.find("#event-session-info").html(eventObject.sessionInfo);
}

/*
 * function is used to display the floor map image in #floor-map
 */
function displayFloorMap(floorMapId, returnUrl)
{
    var floorMapObject = floorMapList[floorMapId];
    $.mobile.activePage.find("#back-url").attr('href','#' + decodeURIComponent(returnUrl));
    floorMapImage = document.createElement('img');
    putImageToObject(floorMapImage, "floorMapList_" + floorMapObject.imageId);
    $.mobile.activePage.find("#map-image").html(floorMapImage);
    $.mobile.activePage.find("#map-description").html(floorMapObject.longDescription);
}

/*
 *  function is used to fill data in #sessions
 */
function fillSessionsPageData(listViewObject, selectedOption, showHeaders)
{
    if (selectedOption == "all")
    {
        addEventListItems(scheduleList, listViewObject, 'add', 'sessions');
    }
    else
    {
        var html = '';
    
        // fetching distinct selected options time from the list i.e. topics/presenters/categories
        var filteredListHeaders = fetchFilteredListHeaders(scheduleList, selectedOption);
        // listForFilteredHeader will contain list for current header in iteration
        var listForFilteredHeader = '';
        // empty the <UL>, this removes previous data
        $(listViewObject).html("");
        $.each(filteredListHeaders, function(index, value) {
            if (showHeaders)
            {
                // inserting the heading <li> tags
                $(listViewObject).append($('<li/>', {
                     'data-role': "list-divider",
                     'role': "heading",
                     'text': value
                }));
            }
            listForFilteredHeader = fetchListForHeader(scheduleList, selectedOption, value);
            addEventListItems(listForFilteredHeader, listViewObject, 'append', 'sessions');
        });
    }
    $(listViewObject).listview('refresh');
}

/*
 * function returns distinct values of attributes that occurs in the list
 * Sting listForSelectedOption = the attributes whose distinct values are needed
 */
function fetchFilteredListHeaders(list, listForSelectedOption)
{
    var returnList = [];
    $.each(list, function(eventId, eventData) {
        if (returnList.indexOf(eventData[listForSelectedOption]) == -1)
        {
            returnList.push(eventData[listForSelectedOption]);
        }
    });
    return returnList.sort();
}
/*
 * function returns list items for the specified header
 * e.g if selectedOption = topic & value = topic 1
 * then function will return all events that are of topic 1
 */
function fetchListForHeader(list, selectedOption, value)
{
    var returnList = {};
    $.each(list, function(key, val) {
        if ( val[selectedOption] == value ) {
            returnList[key] = val;
        }
    });
    return returnList;
}

/*
 * function adds events to the list
 */
function addEventListItems(list, listViewObject, operation, returnUrl)
{
    if (operation == 'add')
    {
        $(listViewObject).html("");
    }
    $.each(list, function(index, item) {
        renderEvent(item.id, listViewObject, returnUrl);
    });
}

/**
 * appends single presenter to the list
 */
function renderPresenter(presenterId, listViewObject, returnUrl)
{
    var item = presentersList[presenterId];
    // data to be inserted in the list
    var html = '';
    var presenterImage = $("<img/>",{
        'height' : '32',
        'width'  : '32'
    });
    putImageToObject(presenterImage, "presentersList_" + item.imageId);
    html = document.createElement('div');
    $(html).addClass('presenter-details');
    $(html).append($('<div/>', {
        'class': 'thumb-holder'
    }).append(presenterImage)
    ).append($('<div/>', {
        'class': 'presenter-name'
    }).append($('<strong/>', {
        'text' : item.name
    }))).append($('<div/>', {
        'class': 'presenter-description short_description',
        'html' : item.shortDescription
    }));

    var hrefValue = '';
    hrefValue = '#presenter-full-view?presenterId=' + presenterId + '&presenterFullViewReturnUrl=' + returnUrl;
    if ($.mobile.pageData != null)
    {
        if ($.mobile.pageData.scheduleFullView_returnUrl != null && $.mobile.pageData.scheduleFullView_returnUrl != 'undefined')
        {
            hrefValue += '&scheduleFullView_returnUrl=' + $.mobile.pageData.scheduleFullView_returnUrl;
        }
        if ($.mobile.pageData.viewSpeakersReturnUrl != null && $.mobile.pageData.viewSpeakersReturnUrl != 'undefined')
        {
            hrefValue += '&viewSpeakersReturnUrl=' + $.mobile.pageData.viewSpeakersReturnUrl;
        }
        if ($.mobile.pageData.eventId != null && $.mobile.pageData.eventId != 'undefined')
        {
            hrefValue += '&eventId=' + $.mobile.pageData.eventId;
        }
    }
    // inserting the <li> tags containing links
    $(listViewObject).append($('<li/>', {
        'data-theme': "c"
    }).append($('<a/>', {
        'href': hrefValue,
        'data-transition': 'slide',
        'html': html
    })));
}

/**
 * appends single event to the list
 */
function renderEvent(eventId, listViewObject, returnUrl)
{
    var item = scheduleList[eventId];
    // data to be inserted in the list
    var html = '';
    var startsAt = item.startsAt.match(/.{1,2}/g);
    var endsAt = item.endsAt.match(/.{1,2}/g);
    if (startsAt.length == 2)
    {
        startsAt = startsAt[0] + ':' + startsAt[1];
    }
    else
    {
        startsAt = item.startsAt;
    }
    if (endsAt.length == 2)
    {
        endsAt = endsAt[0] + ':' + endsAt[1];
    }
    else
    {
        endsAt = item.endsAt;
    }
    
    html = document.createElement('div');
    $(html).addClass('event-details');
    $(html).append($('<div/>', {
        'class': 'event-title'
    }).append($('<strong/>', {
        'text' : item.title
    })));
    $(html).append($('<div/>', {
        'class': 'event-venue',
        'text' : item.venue
    }));
    $(html).append($('<div/>', {
        'class': 'event-duration',
        'text' : startsAt + '-' + endsAt + ' [ '+item.date+' ]'
    }));
    $(html).append($('<div/>', {
        'class': 'event-small-description',
        'text' : item.type
    }));
    var linkValue = '#schedule-full-view?eventId=' + item.id + '&scheduleFullView_returnUrl=' + returnUrl;
    var itemLink = $('<a/>', {
        'href': linkValue,
        'data-transition': 'slide',
        'html': html
    });
    
    var listItem = $('<li/>', {
        'data-theme': "c"
    }).append(itemLink);
    if (item.color != null)
    {
    	// adding backgroud color to list item
        $(listItem).css({'background-color' : '#' + item.color, 'background-image' : 'none'});
    }
    // inserting the <li> tags containing links
    $(listViewObject).append(listItem);
}

/*
 * function adds presenters to the list in #presenters-list
 */
function addPresentersListItems(list, listViewObject, operation, returnUrl)
{
    if (operation == 'add')
    {
        $(listViewObject).html("");
    }
    $.each(list, function(index, item) {
        renderPresenter(item.id, listViewObject, returnUrl);
    });
}

/*
 * function displays presenter full view in #presenter-full-view
 */
function displayPresenterDetails(presenterId)
{
    var presenter = presentersList[presenterId];
    var presenterImage = $("<img/>");
    putImageToObject(presenterImage, "presentersList_" + presenter.imageId);
    $.mobile.activePage.find("#presenter-name").html(presenter.name);
    $.mobile.activePage.find("#presenter-image").html(presenterImage);
    $.mobile.activePage.find("#presenter-description").html(presenter.longDescription);
    var eventsLink = '';
    if ($.mobile.pageData.presenterFullViewReturnUrl == 'presenters')
    {
        $.mobile.activePage.find('.presenter-events-icon').removeClass('hidden');
        eventsLink = '#speaker-sessions?presenterId=' + presenterId + '&speakerSessionsReturnUrl=presenter-full-view&presenterFullViewReturnUrl=' + $.mobile.pageData.presenterFullViewReturnUrl;
        $.mobile.activePage.find('.presenter-events-link').attr('href', eventsLink);
    }
    else
    {
        eventsLink = '#speaker-sessions?presenterId=' + presenterId + '&speakerSessionsReturnUrl=presenter-full-view&presenterFullViewReturnUrl=' + $.mobile.pageData.presenterFullViewReturnUrl;
        if ($.mobile.pageData.eventId != null && $.mobile.pageData.eventId != 'undefined')
        {
            eventsLink += '&eventId=' + $.mobile.pageData.eventId;
        }
        $.mobile.activePage.find('.presenter-events-link').attr('href', eventsLink);
    }
    if (isGuestUser())
    {
        $.mobile.activePage.find("#speaker-rate").attr('href','javascript:ui_alert("Login Required");');
    }
    else
    {
        $.mobile.activePage.find("#speaker-rate").attr('href','#speaker-rate?presenterId=' + presenterId);
    }
    if ($.mobile.pageData.presenterFullViewReturnUrl)
    {
        if ( $.mobile.pageData == null || $.mobile.pageData.startUrl == 'undefined' || $.mobile.pageData.startUrl == 'presenters' )
        {
            $.mobile.activePage.find(".back-url").attr("href", '#presenters');
        }
        else
        {
            var backUrl = "#" + $.mobile.pageData.presenterFullViewReturnUrl + '?';
            if ($.mobile.pageData.scheduleFullView_returnUrl != 'undefined' && $.mobile.pageData.scheduleFullView_returnUrl != null)
            {
                backUrl += '&scheduleFullView_returnUrl=' + $.mobile.pageData.scheduleFullView_returnUrl;
            }
            if ($.mobile.pageData.viewSpeakersReturnUrl != 'undefined' && $.mobile.pageData.viewSpeakersReturnUrl != null)
            {
                backUrl += '&viewSpeakersReturnUrl=' + $.mobile.pageData.viewSpeakersReturnUrl;
            }
            if ($.mobile.pageData.eventId != 'undefined' && $.mobile.pageData.eventId != null)
            {
                backUrl += '&eventId=' + $.mobile.pageData.eventId;
            }
            $.mobile.activePage.find(".back-url").attr("href", backUrl);
        }
    }
    if (startUrl == 'presenters')
    {
        $.mobile.activePage.find(".back-url").attr("href", '#' + startUrl);
    }
}

/*
 * function adds maps to the list in #items-list in #maps page
 */
function addMapsListItems(list, listViewObject, operation, returnUrl)
{
    if (operation == 'add')
    {
        $(listViewObject).html("");
    }
    $.each(list, function(index, item) {
        // data to be inserted in the list
        html = '';
        var mapImage = $("<img />", {
            'height'    : '32',
            'width'     : '32'
        });
        putImageToObject(mapImage, "floorMapList_" + item.imageId);
        html = document.createElement('div');
        $(html).addClass('presenter-details');
        $(html).append($('<div/>', {
            'class': 'thumb-holder'
        }).append(mapImage)
        ).append($('<div/>', {
            'class': 'maps-description  short_description',
            'html' : item.shortDescription
        }));

        // inserting the <li> tags containing links
        $(listViewObject).append($('<li/>', {
            'data-theme': "c"
        }).append($('<a/>', {
            'href': '#floor-map?floorMapId=' + index + '&returnUrl=' + encodeURIComponent("attendee-information"),
            'data-transition': 'slide',
            'html': html
        })));
    });
}

/*
 * function adds exhibitors to the list
 */
function addExhibitorsListItems(list, listViewObject, operation, returnUrl)
{
    if (operation == 'add')
    {
        $(listViewObject).html("");
    }
    $.each(list, function(index, item) {
        // data to be inserted in the list
        html = '';
        html = document.createElement('div');
        $(html).addClass('presenter-details');
        $(html).append($('<div/>', {
            'class': 'exhibitor-name',
            'text' : item.name
        }));

        // inserting the <li> tags containing links
        $(listViewObject).append($('<li/>', {
            'data-theme': "c"
        }).append($('<a/>', {
            'href': '#exhibitor-full-view?exhibitorId=' + index + '&returnUrl=' + encodeURIComponent(returnUrl),
            'data-transition': 'slide',
            'html': html
        })));
    });
}

/*
 * funciton is used to display exhibitor full view in #exhibitor-full-view page
 */
function displayExhibitorDetails(exhibitorId, returnUrl)
{
    var exhibitor = exhibitorsList[exhibitorId];
    $.mobile.activePage.find("#exhibitor-name").html(exhibitor.name);
    $.mobile.activePage.find("#exhibitor-booth").html(exhibitor.booth);
    $.mobile.activePage.find("#exhibitor-description").html(exhibitor.description);
    $.mobile.activePage.find("#back-url").attr("href", "#" + returnUrl);
}

/*
 * funciton is used to display news full view in #news-full-view page
 */
function displayNewsDetails(newsId, returnUrl)
{
    var news = newsList[newsId];
    $.mobile.activePage.find("#news-title").html(news.title);
    $.mobile.activePage.find("#news-description").html(news.description);
    $.mobile.activePage.find("#back-url").attr("href", "#" + returnUrl);
}

/*
 * function adds news items to the list
 */
function addNewsListItems(list, listViewObject, operation, returnUrl)
{
    if (operation == 'add')
    {
        $(listViewObject).html("");
    }
    $.each(list, function(index, item) {
        // data to be inserted in the list
        html = '';
        html = document.createElement('div');
        $(html).addClass('presenter-details');
        $(html).append($('<div/>', {
            'class': 'news-title',
            'text' : item.title
        }));

        // inserting the <li> tags containing links
        $(listViewObject).append($('<li/>', {
            'data-theme': "c"
        }).append($('<a/>', {
            'href': '#news-full-view?newsId=' + index + '&returnUrl=' + encodeURIComponent(returnUrl),
            'data-transition': 'slide',
            'html': html
        })));
    });
}

/*
 * function adds notification items to the list
 */
function addNotificationListItems(list, listViewObject, operation)
{
    if (operation == 'add')
    {
        $(listViewObject).html("");
    }
    $.each(list, function(index, item) {
        // data to be inserted in the list
        html = '';
        html = document.createElement('div');
        $(html).addClass('presenter-details');
        $(html).append($('<div/>', {
            'class': 'notification-title',
            'text' : item
        }));

        // inserting the <li> tags containing links
        $(listViewObject).append($('<li/>', {
            'data-theme': "c"
        }).append($('<span/>', {
            'html': html
        })));
    });
}

/*
 * function adds sponsors to the list in #presenters-list
 */
function addSponsorsListItems(list, listViewObject, operation, returnUrl)
{
    if (operation == 'add')
    {
        $(listViewObject).html("");
    }
    $.each(list, function(index, item) {
        // data to be inserted in the list
        html = '';
        var sponsorImage = $("<img />");
        putImageToObject(sponsorImage, "sponsorsList_" + item.imageId)
        html = document.createElement('div');
        $(html).addClass('sponsor-details');
        $(html).append($('<div/>', {
            'class': 'thumb-holder'
        }).append(sponsorImage)
        ).append($('<div/>', {
            'class': 'sponsor-name'
        }).append($('<strong/>', {
            'text' : item.name
        }))).append($('<div/>', {
            'class': 'sponsor-url'
        }).append($('<a/>',{
            'href': 'javascript:;',
            'onclick': "window.open('" + encodeURI(item.url) + "', '_system')",
            'data-role': 'link',
            'text' : item.url
        })));

        // inserting the <li> tags containing links
        $(listViewObject).append($('<li/>', {
            'data-theme': "c"
        }).append($('<a/>', {
            'href': '#sponsor-full-view?sponsorId=' + index + '&returnUrl=' + returnUrl,
            'data-transition': 'slide',
            'html': html
        })));
    });
}

/*
 * function displays sponsor full view in #presenter-full-view
 */
function displaySponsorDetails(sponsorId)
{
    var sponsor = sponsorsList[sponsorId];
    var sponsorImage = $("<img />");
    putImageToObject(sponsorImage, "sponsorsList_" + sponsor.imageId)
    $.mobile.activePage.find("#sponsor-name").html(sponsor.name);
    $.mobile.activePage.find("#sponsor-image").html(sponsorImage);
    $.mobile.activePage.find("#sponsor-url").html($('<a/>',{
        'href': 'javascript:;',
        'onclick': "window.open('" + encodeURI(sponsor.url) + "', '_system')",
        'text' : sponsor.url
    }));
    $.mobile.activePage.find("#sponsor-description").html(sponsor.description);

}

/*
 * function extracts the images by the column value
 */
function fetchImagesFromJSON(data, listType)
{
    $.each(data, function(index, item) {
    	// checking if the image already exists in db
        db.transaction(function(tx){
            tx.executeSql('SELECT * FROM images WHERE id like "'+ listType + '_' + item.imageId +'" LIMIT 1', [], function(tx,result){
				// if image does not exist in db then fetch the image from server
                if (result.rows.length == 0)
                {
                    convertImageToBase64(item.imageUrl, item.imageId ,listType,item.id);
                }
            }, errorCB);
        }, errorCB, successCB);
    });
}

/*
 *  function is used to fill data in #itinerary
 */
function fillItineraryPageData(listViewObject)
{
    $(listViewObject).html("");
    
    if (window.localStorage.getItem("userItineraries") && JSON.parse(window.localStorage.getItem("userItineraries")).length > 0)
    {
        $.mobile.activePage.find(".noItineraries").addClass("hidden");
        $.each(JSON.parse(window.localStorage.getItem("userItineraries")), function(index, value) {
            renderEvent(value, listViewObject, "itinerary");
        });
        $(listViewObject).listview('refresh');
    }
    else
    {
        $.mobile.activePage.find(".noItineraries").removeClass("hidden");
    }
}

/*
 * function checks if event item exists in the new fetched events and
 * if event does not exist but is there in user itineraries
 * then delete it from there also
 */
function refreshItineraries()
{
    
    if (window.localStorage.getItem("userItineraries") && JSON.parse(window.localStorage.getItem("userItineraries")).length > 0)
    {
        var userItineraries = JSON.parse(window.localStorage.getItem("userItineraries"));
        $.each(userItineraries, function(index, value) {
            if (scheduleList[value])
            {
                //do nothing
            }
            else
            {
                //delete from userItineraries list
                userItineraries.splice(index, 1);
            }
        });
        window.localStorage.setItem("userItineraries", JSON.stringify(userItineraries));
    }
}
/*
 *  function is used to retrieve the base64 encoded image  from the backend
 *  and saves it to the local database [ WebSql ]
 */
function convertImageToBase64(url, imageId, listType, itemId)
{
    var data = {"id" : encodeURI(imageId)};
    var imageInfo = "";
    $.ajax({
        url: url,   // url for AJAX call
        dataType: "json",
        data: data,
        type: "POST",
        success: function (result) {
            // saving returned JSON to a variable
            imageInfo = "data:"+ result.mimeType +";base64," + result.encodedImage;
            saveImage(listType+'_'+imageId, imageInfo);
        },
        error: function (request,error) {
            console.log("Error has occurred");
        }
    });
}

/*
 * function saves encoded image to database [ WebSql ]
 */
function saveImage(key, imageInfo)
{
    db.transaction(function(tx){
        tx.executeSql('INSERT INTO images values ("'+ key +'", "'+ imageInfo +'")');
    }, errorCB);
}

/*
 * function updates encoded image in database on behalf of id [ WebSql ]
 */
function updateImage(key, imageInfo)
{
    db.transaction(function(tx){
        tx.executeSql('UPDATE images SET data="'+ imageInfo + '" WHERE id="'+ key +'"');
    }, errorCB);
}

/*
 * function fetches image from DB and places it to the image object
 */
function putImageToObject(imageObject, key)
{
    db.transaction(function(tx){
        tx.executeSql('SELECT * FROM images where id like "'+ key +'" LIMIT 1', [], function(tx,result){
            if (result.rows.length == 1)
            {
                $(imageObject).prop("src", result.rows.item(0).data);
            }
        }, errorCB);
    }, errorCB, successCB);
}

/**
 * function performs the logout action
 */
function userLogoutAction()
{
    showLoading();
    window.localStorage.removeItem("userDetails");
}
/**
 * function is used to send message to the server with ajax request
 */
function sendMessageFormAction(event)
{
    event.preventDefault();
    var message = $("#message-box").val();
    if (message == "")
    {
        ui_alert("Message can not be empty");
        return false;
    }
    else
    {
        if (!isGuestUser())
        {
            showLoading();
            var userDetails = JSON.parse(window.localStorage.getItem("userDetails"));
            data = {
                'UserMessages[user_id]' : userDetails.id,
                'UserMessages[message]' : message
            };
            $.ajax({
                url: baseUrl + "/site/saveUserMessage",   // url for AJAX call
                dataType: "json",
                data: data,
                type: "POST",
                async: false,
                beforeSend: function() {
                    // showing loading icon before AJAX request
                    showLoading();
                },
                success: function (result) {
                    if (result.success == "1")
                    {
                        alert(result.message);
                        hideLoading();
                    }
                    else
                    {
                        alert(result.message);
                        hideLoading();
                        return false;
                    }
                },
                error: function (request,error) {
                    alert('An active internet connection is required to run this application');
                    hideLoading();
                    return false;
                }
            });
        }
        else
        {
            ui_alert("Login Required");
            return false;
        }
    }
    return false;
}

/**
 *  function is used to fill data in #session-questions
 */
function fillSessionQuestionsPageData(listViewObject, eventId)
{
    var eventRow = scheduleList[eventId];
    var sessionQuestions = eventRow.eventQuestions;
    
    $(listViewObject).html("");
    var hrefValue = '#session-answer-question?eventId=' + eventId;
    
    $.each(sessionQuestions, function(index, item) {
        // data to be inserted in the list
        html = '';
        html = document.createElement('div');
        $(html).addClass('session-question-list-item');
        $(html).append($('<div/>', {
            'class': 'session-q',
            'text' : item.question
        }));

        // inserting the <li> tags containing links
        $(listViewObject).append($('<li/>', {
            'data-theme': "c"
        }).append($('<a />', {
            'href': hrefValue + '&event_question_id='+item.id,
            'data-transition': 'slide',
            'html': html
        })));
    });
    
    $(listViewObject).listview('refresh');
}