var baseUrl = 'http://pedicon2015.eventroller.com/admin.php';
var notificationsData;
var gcmSenderID = "243676332701";
$(function(){
    notificationsData = [];
    if (window.localStorage.getItem('notificationsData'))
    {
        notificationsData = JSON.parse(window.localStorage.getItem('notificationsData'));
    }
    $("#continue-as-guest").on('click', continueAsGuestAction);
});
/**
 * function checks if the user is logged in or not
 */
function isGuestUser()
{
    var returnValue = true;
    var userDetails = window.localStorage.getItem("userDetails");
    if (userDetails)
    {
        returnValue = false;
    }
    return returnValue;
}

/**
 * code for push notification starts
 */
function onDeviceReady() {
    if (parseFloat(window.device.version) === 7.0) {
        console.log("iOS 7 Status Bar Fix");
        StatusBar.overlaysWebView(false);
        StatusBar.backgroundColorByName("black");
        StatusBar.styleLightContent();
    }
    try
    {
        pushNotification = window.plugins.pushNotification;
        if (device.platform == 'android' || device.platform == 'Android') {
            pushNotification.register(successHandler, errorHandler, {"senderID":gcmSenderID,"ecb":"onNotificationGCM"});		// required!
        } else {
            pushNotification.register(tokenHandler, errorHandler, {"badge":"true","sound":"true","alert":"true","ecb":"onNotificationAPN"});	// required!
        }
    }
    catch(err)
    {
        txt="There was an error on this page.\n\n";
        txt+="Error description: " + err.message + "\n\n";
    }
}

// handle APNS notifications for iOS
function onNotificationAPN(e) {
    setTimeout(function(){
        if (e.alert)
        {
            notificationsData = [];
            if (window.localStorage.getItem('notificationsData'))
            {
                notificationsData = JSON.parse(window.localStorage.getItem('notificationsData'));
            }
             notificationsData.push(e.alert);
             window.localStorage.setItem('notificationsData', JSON.stringify(notificationsData));
        }

        if (e.sound)
        {
            var snd = new Media(e.sound);
            snd.play();
        }

        if (e.badge)
        {
            pushNotification.setApplicationIconBadgeNumber(successHandler, e.badge);
        }
    },1000);
}

// handle GCM notifications for Android
function onNotificationGCM(e) {
    setTimeout(function(){
        switch( e.event )
        {
            case 'registered':
            if ( e.regid.length > 0 )
            {
                // Your GCM push server needs to know the regID before it can push to this device
                // here is where you might want to send it the regID for later use.
                var userDetailsToSend = "";
                if (!isGuestUser())
                {
                    userDetailsToSend = window.localStorage.getItem("userDetails");
                }
                registerDeviceToken(e.regid, device.platform, userDetailsToSend);
            }
            break;

            case 'message':
                // if this flag is set, this notification happened while we were in the foreground.
                // you might want to play a sound to get the user's attention, throw up a dialog, etc.
                if (e.foreground)
                {
                    // if the notification contains a soundname, play it.
                    var my_media = new Media("/android_asset/www/"+e.soundname);
                    my_media.play();
                }
                else
                {	// otherwise we were launched because the user touched a notification in the notification tray.
                    if (e.coldstart)
                    {
                        //alert('--COLDSTART NOTIFICATION--');
                    }
                    else
                    {
                        //alert('--BACKGROUND NOTIFICATION--');
                    }
                }
                notificationsData = [];
                if (window.localStorage.getItem('notificationsData'))
                {
                    notificationsData = JSON.parse(window.localStorage.getItem('notificationsData'));
                }
                notificationsData.push(e.payload.message);
                window.localStorage.setItem('notificationsData', JSON.stringify(notificationsData));
            break;

            case 'error':
                //alert('ERROR -> MSG:' + e.msg);
            break;

            default:
                //alert('EVENT -> Unknown, an event was received and we do not know what it is');
            break;
        }
    }, 1000);
}

function tokenHandler (result) {
    // Your iOS push server needs to know the token before it can push to this device
    // here is where you might want to send it the token for later use.
    userDetailsToSend = "";
    
    if (!isGuestUser())
    {
        userDetailsToSend = window.localStorage.getItem("userDetails");
    }
    registerDeviceToken(result, device.platform, userDetailsToSend);
}

function successHandler (result) {
    //alert('success:'+ result );
}

function errorHandler (error) {
    //alert('error:'+ error);
}

function registerDeviceToken(deviceToken, deviceType, userDetails)
{
    //alert("register request");
    var sendRegisterDeviceRequest = true;
    // check if device token already registered
    if (window.localStorage.getItem('deviceToken'))
    {
        sendRegisterDeviceRequest = false;
        // token is same as registered one
        if ( deviceToken == window.localStorage.getItem('deviceToken'))
        {
            // if user has logged in after token registeration
            if (window.localStorage.getItem('deviceRegisteredBy') == '' && userDetails != '')
            {
                sendRegisterDeviceRequest = true;
            }
            else if (window.localStorage.getItem('deviceRegisteredBy') != '' && userDetails != '')
            {
                // check if register request is sent by same user again
                if (window.localStorage.getItem('deviceRegisteredBy') == JSON.parse(userDetails).id)
                {
                    sendRegisterDeviceRequest = false;
                }
                // if user has logged in using different credentials
                else
                {
                    sendRegisterDeviceRequest = true;
                }
            }
        }
        else
        {
            sendRegisterDeviceRequest = true;
        }
    }
    if (sendRegisterDeviceRequest)
    {
        var data = {
            'deviceToken' : deviceToken,
            'deviceType' : deviceType,
            'userDetails' : userDetails
        };
        $.ajax({
            url: baseUrl + "/site/registerUserDevice",   // url for AJAX call
            dataType: "json",
            data: data,
            type: "POST",
            async: false,
            beforeSend: function() {
                // showing loading icon before AJAX request
                $.mobile.showPageLoadingMsg(true);
            },
            success: function (result) {
                if (result.success == "1")
                {
                    window.localStorage.setItem('deviceToken', deviceToken);
                    var deviceRegisteredBy = "";
                    if (userDetails != "")
                    {
                        userDetails = JSON.parse(userDetails);
                        deviceRegisteredBy = userDetails.id;
                    }
                    window.localStorage.setItem('deviceRegisteredBy', deviceRegisteredBy);
                }
                else
                {
                    $.mobile.hidePageLoadingMsg();
                }
            },
            complete: function () {
                $.mobile.hidePageLoadingMsg();
            }
        });
    }
}

/**
 * function makes ajax request to get Data from the server
 */
function fetchAjaxData()
{
    showLoading();
    sleepFor(1000);
    var data = {"version" : 0};
    if (window.localStorage.getItem("versionInfo") != null)
    {
        data.version = window.localStorage.getItem("versionInfo");
    }
    var list;
    $.ajax({
        url: baseUrl + "/site/fetchAppData",   // url for AJAX call
        dataType: "json",
        data: data,
        type: "POST",
        async: false,
        success: function (result) {
            // saving returned JSON to a variable
            list = result;
        },
        error: function (request,error) {
            list = false;
        },
        complete: function() {
            hideLoading();
        }
    });
    return list;
}

/**
 * function is used to check whether application is successful in fetching the data once
 * or not
 * called when user clicks the "Continue as Guest" button
 */
function continueAsGuestAction(event)
{
    event.preventDefault();
    showLoading();
    setTimeout(function(){
        if (window.localStorage.getItem("ajaxFetchedData") == '' || window.localStorage.getItem("ajaxFetchedData") == null)
        {
            var ajaxFetchedData = '';
            if (checkConnection())
            {
                ajaxFetchedData = fetchAjaxData();
            }
            if (ajaxFetchedData == '' || ajaxFetchedData == false || ajaxFetchedData == null)
            {
                alert('The Application is not ready to use, internet is required for initial caching of data');
                hideLoading();
            }
            else
            {
                window.localStorage.setItem("ajaxFetchedData", JSON.stringify(ajaxFetchedData));
                window.localStorage.setItem("versionInfo", ajaxFetchedData.version);
                var logoImage = ajaxFetchedData.logoImage;
                var logoImageInfo = "data:"+ logoImage.type +";base64," + logoImage.data;
                window.localStorage.setItem("logoImageData", logoImageInfo);
                window.localStorage.setItem("isLogoImageChanged", "true");
                window.location = 'main.html';
            }
        }
        else
        {
            window.location = 'main.html';
        }
    }, 500);
}

/**
 * generic function to make an ajax request
 */
function sendAjaxRequest(url, data, requestType,dataType)
{
    var returnData = false;
    $.ajax({
        url: url,   // url for AJAX call
        dataType: dataType,
        data: data,
        type: requestType,
        async: false,
        beforeSend: function() {
            // showing loading icon before AJAX request
            $.mobile.showPageLoadingMsg(true);
        },
        complete: function() {
            // hiding loading icon after AJAX request
            $.mobile.hidePageLoadingMsg();
        },
        success: function (result) {
            // saving returned JSON to a variable
            returnData = result;
        },
        error: function (request,error) {
            returnData = false;
        }
    });
    return returnData;
}

/*
 * function is used to show the loading message
 */
function showLoading()
{
    //$.mobile.showPageLoadingMsg("a", "Loading please wait");
//    $.mobile.loading('show');
    $.blockUI({
        css: {
            border: 'none',
            padding: '15px',
            backgroundColor: '#000',
            '-webkit-border-radius': '10px',
            '-moz-border-radius': '10px',
            opacity: .5,
            color: '#fff',
        },
        message: 'Loading...'
    });

}

/*
 * function is used to hide the loading message
 */
function hideLoading()
{
    //$.mobile.hidePageLoadingMsg();
    //$.mobile.loading('hide');
    $.unblockUI();
}

function getLengthOfObject(obj)
{
    var returnVal = 0;
    if (obj != null && obj != 'undefined')
    {
        returnVal = Object.keys(obj).length;
    }
    return returnVal;
}

function ui_alert(msg, displayTime)
{
    if(displayTime == null || displayTime == 'undefined')
    {
        displayTime = 2000;
    }
    msg = msg.replace('\n', '<br/>');
    $.blockUI({
        message: '<strong>'+ msg +'</strong>'
        ,timeout: displayTime
    });
}

function getUserSelectedOption(event_question_id)
{
    var returnVal = null;
    var userDetails = window.localStorage.getItem("userDetails");
    if (userDetails)
    {
        userDetails = JSON.parse(userDetails);
        if (userDetails && userDetails.eventQuestionAnswers)
        {
            $.each(userDetails.eventQuestionAnswers, function(index, elem){
                if (elem.event_question_id == event_question_id)
                    returnVal = elem.selected_option;
            });
        }
    }
    return returnVal;
}

function setUserSelectedOption(event_question_id, selected_option)
{
    var userDetails = window.localStorage.getItem("userDetails");
    if (userDetails)
    {
        userDetails = JSON.parse(userDetails);
        if (userDetails && userDetails.eventQuestionAnswers)
        {
            var userEventQuestionAnswers = userDetails.eventQuestionAnswers
            var indexOfAnswer = null;
            $.each(userEventQuestionAnswers, function(index, elem){
                if (elem.event_question_id == event_question_id)
                    indexOfAnswer = index;
            });
            if (indexOfAnswer != null)
            {
                userEventQuestionAnswers[indexOfAnswer].selected_option = selected_option;
            }
            else
            {
                var toPush = {
                    event_question_id: event_question_id,
                    selected_option: selected_option,
                };
                userEventQuestionAnswers.push(toPush);
            }
            userDetails.eventQuestionAnswers = userEventQuestionAnswers;
            window.localStorage.setItem("userDetails", JSON.stringify(userDetails));
        }
    }
}

function registerLocalPush(options)
{
    if (window.plugin && window.plugin.notification && window.plugin.notification.local)
    {
        var _defaults = {
            id: 1,
            date: new Date(new Date().getTime() + 60*1000),
            message: 'You have received a new message.',
            title: 'Pedicon 2015',
            repeat: null,
            badge: 1,
            json: {
                id: 1,
            },
            autoCancel: true,
            ongoing: false,
        };

        var data = $.extend( {}, _defaults, options );
        window.plugin.notification.local.add({
            id:         data.id,  
            date:       data.date,    
            message:    data.message,  
            title:      data.title,  
            repeat:     data.repeat,  // Either 'secondly', 'minutely', 'hourly', 'daily', 'weekly', 'monthly' or 'yearly'
            badge:      data.badgeNumber,  // Displays number badge to notification
            //sound:      String,
            json:       data.data,  // Data to be passed through the notification
            autoCancel: data.autoCancel, // Setting this flag and the notification is automatically canceled when the user clicks it
            ongoing:    data.ongoing, // Prevent clearing of notification (Android only)
        });
    }
}
function unRegisterLocalPush(id)
{
    if (window.plugin && window.plugin.notification && window.plugin.notification.local)
    {
        window.plugin.notification.local.isScheduled(id, function (isScheduled) {
            window.plugin.notification.local.cancel(id);
        });
    }
}

function sleepFor( sleepDuration ){
    var now = new Date().getTime();
    while(new Date().getTime() < now + sleepDuration){ /* do nothing */ } 
}


function checkConnection() {
    if (navigator && navigator.connection && navigator.connection.type)
    {
        var networkState = navigator.connection.type;
        var states = {};
        states[Connection.UNKNOWN]  = 'Unknown connection';
        states[Connection.ETHERNET] = 'Ethernet connection';
        states[Connection.WIFI]     = 'WiFi connection';
        states[Connection.CELL_2G]  = 'Cell 2G connection';
        states[Connection.CELL_3G]  = 'Cell 3G connection';
        states[Connection.CELL_4G]  = 'Cell 4G connection';
        states[Connection.NONE]     = false;

        if (states[networkState] !== false)
        {
            return true;
        }
        else
        {
            return false
        }
    }
    else
    {
        return true;
    }
}